<script lang="ts" setup>
import { Close } from 'slippers-ui/icons';

/**
 * Used for blocks of content that needs to be shown within a modal.
 * For Videos, use CommonVideoModal. For Navattic Demos, use CommonDemoModal.
 * In Buyer Experience, this was used on our e-group, board of directors, and pricing pages.
 */

const emit = defineEmits(['close']);
const modalCloseButton = ref<HTMLButtonElement | null>(null);

const emitClose = () => {
  emit('close');
};

onMounted(() => {
  document.querySelector('body')?.classList.add('noScroll');
  modalCloseButton.value?.focus();
});

onUnmounted(() => {
  document.querySelector('body')?.classList.remove('noScroll');
});
</script>

<template>
  <div class="backdrop" @click.self="emitClose">
    <div role="dialog" aria-modal="true" class="modal" data-aos="zoom-in" data-aos-duration="300">
      <div class="modal__content">
        <button ref="modalCloseButton" aria-label="Close dialog" type="button" class="close-button" @click="emitClose">
          <SlpIcon :icon="Close" size="lg" />
        </button>
        <slot></slot>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.backdrop {
  position: fixed;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  background-color: rgba($color-surface-700, 0.85);
  display: flex;
  justify-content: center;
  align-items: center;
  z-index: 1026;
}

.close-button {
  width: 30px;
  margin: 4px 12px 0 auto;
  text-align: center;
  position: relative;
  border: none;
  cursor: pointer;
  display: block;
}

.modal {
  background: white;
  display: flex;
  flex-direction: column;
  border-radius: 3px;
  position: relative;
  z-index: 1022;
  margin: 0 1rem;
  @media (max-width: $breakpoint-lg) {
    margin-top: $spacing-96;
  }
  &__content {
    box-sizing: content-box;
  }
}
</style>
